PLSDA.perfomance<- function(data, B, Y) {
  
  df = data
  set.seed(100)
  splda.acc = matrix(numeric(1),B,2)
  colnames(splda.acc) = c('Actual','Permutated')
  proceed = 1
  for (i in 1:B){
    while (proceed) {
      sub<-sample(1:nrow(data),floor(0.75*nrow(data)))
      proceed = ifelse(length(unique(Y[-sub])) > 1 & length(unique(Y[sub])) > 1, 0, 1)
    }
    proceed = 1
    datatemp<-data[sub,]
    datatest<-data[-sub,]
    ## Actual model
    plsda.res <- mixOmics::plsda(datatemp, Y[sub], ncomp = 10, scale = TRUE)
    test.predict <- predict(plsda.res, datatest, dist = "max.dist")
    # store prediction for the 2nd component
    prediction <- factor(test.predict$class$max.dist[,2],levels(Y)) 
    # calculate the error rate of the model
    confusion.mat = caret::confusionMatrix(table(Y[-sub], prediction))
    err <- ifelse(is.na(confusion.mat$byClass[11]), 1, 0) ## If the balanced accuracy is NA, use overall accuracy
    if(err) {
      splda.acc[i,1] = confusion.mat$overall[1]
    }else {
      splda.acc[i,1] = confusion.mat$byClass[11]
    }
    
    ## Permutate model
    Yp = Y[sample(length(Y))]
    plsda.res <- mixOmics::plsda(datatemp, Yp[sub], ncomp = 10, scale = TRUE)
    test.predict <- predict(plsda.res, datatest, dist = "max.dist")
    # store prediction for the 2nd component
    prediction <- factor(test.predict$class$max.dist[,2],levels(Y)) 
    # calculate the error rate of the model
    confusion.mat = caret::confusionMatrix(table(Yp[-sub], prediction))
    err <- ifelse(is.na(confusion.mat$byClass[11]), 1, 0) ## If the balanced accuracy is NA, use overall accuracy
    if(err) {
      splda.acc[i,2] = confusion.mat$overall[1]
    }else {
      splda.acc[i,2] = confusion.mat$byClass[11]
    }
  }
  
  return(splda.acc)
}